/* WARNING: THIS FILE IS AUTOMATICALLY GENERATED FROM A .SM FILE.
 * Changes made here will most likely be overwritten.
 */

/* 
 * (C) 2001 Clemson University and The University of Chicago 
 *
 * See COPYING in top-level directory.
 */

/* pvfs2_get_eattr_sm
 *
 * This state machine handles incoming server geteattr operations.  These
 * are the operations sent by PVFS_sys_geteattr() among others.
 *
 * The pvfs2_prelude_sm is responsible for reading the actual metadata
 * to begin with, because it does this as part of the permission checking
 * process.
 */

#include <string.h>
#include <assert.h>

#include "server-config.h"
#include "pvfs2-server.h"
#include "pvfs2-attr.h"
#include "pvfs2-types.h"
#include "pvfs2-types-debug.h"
#include "pvfs2-util.h"
#include "pint-util.h"

static inline char *get_object_type(int objtype)
{
    static char *obj_types[] =
    {
        "NONE", "METAFILE", "DATAFILE",
        "DIRECTORY", "SYMLINK", "DIRDATA", "UNKNOWN"
    };

    switch(objtype)
    {
        case PVFS_TYPE_NONE:
            return obj_types[0];
        case PVFS_TYPE_METAFILE:
            return obj_types[1];
        case PVFS_TYPE_DATAFILE:
            return obj_types[2];
        case PVFS_TYPE_DIRECTORY:
            return obj_types[3];
        case PVFS_TYPE_SYMLINK:
            return obj_types[4];
        case PVFS_TYPE_DIRDATA:
            return obj_types[5];
    }
    return obj_types[6];
}

static int geteattr_setup_resp(
    PINT_server_op *s_op, job_status_s *js_p);
static int geteattr_read_eattrib(
    PINT_server_op *s_op, job_status_s *js_p);
static int geteattr_check_resp(
    PINT_server_op *s_op, job_status_s *js_p);
static int geteattr_cleanup(
    PINT_server_op *s_op, job_status_s *js_p);

extern PINT_server_trove_keys_s Trove_Common_Keys[];

static union PINT_state_array_values ST_prelude[];
static union PINT_state_array_values ST_setup_resp[];
static union PINT_state_array_values ST_read_eattrib[];
static union PINT_state_array_values ST_check_resp[];
static union PINT_state_array_values ST_final_response[];
static union PINT_state_array_values ST_cleanup[];

struct PINT_state_machine_s pvfs2_get_eattr_sm =
{
	ST_prelude,
	"pvfs2_get_eattr_sm"
};
static union PINT_state_array_values ST_prelude[] = {
(union PINT_state_array_values) "prelude",
(union PINT_state_array_values) &pvfs2_get_eattr_sm,
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_prelude_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_setup_resp,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_setup_resp[] = {
(union PINT_state_array_values) "setup_resp",
(union PINT_state_array_values) &pvfs2_get_eattr_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) geteattr_setup_resp,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) ST_read_eattrib,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_read_eattrib[] = {
(union PINT_state_array_values) "read_eattrib",
(union PINT_state_array_values) &pvfs2_get_eattr_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) geteattr_read_eattrib,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_check_resp
};

static union PINT_state_array_values ST_check_resp[] = {
(union PINT_state_array_values) "check_resp",
(union PINT_state_array_values) &pvfs2_get_eattr_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) geteattr_check_resp,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_final_response
};

static union PINT_state_array_values ST_final_response[] = {
(union PINT_state_array_values) "final_response",
(union PINT_state_array_values) &pvfs2_get_eattr_sm,
(union PINT_state_array_values) 6,
(union PINT_state_array_values) &pvfs2_final_response_sm,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) ST_cleanup
};

static union PINT_state_array_values ST_cleanup[] = {
(union PINT_state_array_values) "cleanup",
(union PINT_state_array_values) &pvfs2_get_eattr_sm,
(union PINT_state_array_values) 0,
(union PINT_state_array_values) geteattr_cleanup,
(union PINT_state_array_values) -1,
(union PINT_state_array_values) 7
};

# 114 "src/server/get-eattr.sm"


/*
 * geteattr_setup_resp()
 * Set up the response - allocate needed resources
 */
static int geteattr_setup_resp(PINT_server_op *s_op, job_status_s *js_p)
{
    int i, tsz;
    PINT_STATE_DEBUG("setup_resp");
    gossip_debug(GOSSIP_GETEATTR_DEBUG,"geteattr requesting %d keys\n",
            s_op->req->u.geteattr.nkey);
    s_op->resp.u.geteattr.val =
        malloc(s_op->req->u.geteattr.nkey*sizeof(PVFS_ds_keyval));
    if (!s_op->resp.u.geteattr.val)
        return -PVFS_ENOMEM;
    s_op->resp.u.geteattr.nkey = s_op->req->u.geteattr.nkey;
    for (i = 0, tsz = 0; i < s_op->req->u.geteattr.nkey; i++)
        tsz += s_op->req->u.geteattr.valsz[i];
    s_op->u.eattr.buffer = malloc(tsz);
    if (!s_op->u.eattr.buffer)
    {
        s_op->resp.u.geteattr.nkey = 0;
        free (s_op->resp.u.geteattr.val);
        return -PVFS_ENOMEM;
    }
    gossip_debug(GOSSIP_GETEATTR_DEBUG,"geteattr buffer size %d bytes\n",
            tsz);
    for (i = 0, tsz = 0; i < s_op->req->u.geteattr.nkey; i++)
    {
        s_op->resp.u.geteattr.val[i].buffer_sz =
            s_op->req->u.geteattr.valsz[i];
        s_op->resp.u.geteattr.val[i].buffer =
            (char *) s_op->u.eattr.buffer + tsz;
        tsz += s_op->req->u.geteattr.valsz[i];
    }
    return 1;
}

/*
 * geteattr_read_eattrib()
 * Here is where the eattrib get read.  Not much to this.
 */
static int geteattr_read_eattrib(
    PINT_server_op *s_op, job_status_s *js_p)
{
    int ret = -PVFS_EINVAL;
    job_id_t i;

    PINT_STATE_DEBUG("read_eattrib");

    js_p->error_code = 0;

    ret = job_trove_keyval_read_list(
        s_op->req->u.geteattr.fs_id,
        s_op->req->u.geteattr.handle,
        s_op->req->u.geteattr.key,
        s_op->resp.u.geteattr.val,
        s_op->req->u.geteattr.nkey,
        0,
        NULL,
        s_op,
        0,
        js_p,
        &i,
        server_job_context);

    return ret;
}

/*
 * geteattr_check_resp()
 * Check the response - handle any errors
 */
static int geteattr_check_resp(PINT_server_op *s_op, job_status_s *js_p)
{
    int k;
    PINT_STATE_DEBUG("check_resp");
    gossip_debug(GOSSIP_GETEATTR_DEBUG,"geteattr returning %d values\n",
            s_op->resp.u.geteattr.nkey);
    /* put the returned read buffer size in buffer_sz */
    gossip_debug(GOSSIP_GETEATTR_DEBUG,"status %d error_code %d nkeys %d\n",
            s_op->resp.status, js_p->error_code, s_op->resp.u.geteattr.nkey);
    /* it is the only thing returned across the wire */
    for (k = 0; k < s_op->resp.u.geteattr.nkey; k++)
    {
        if (js_p->error_code == 0)
        {
            s_op->resp.u.geteattr.val[k].buffer_sz =
                s_op->resp.u.geteattr.val[k].read_sz;
            gossip_debug(GOSSIP_GETEATTR_DEBUG, "key %s, read_sz = %d\n",
                (char *) s_op->req->u.geteattr.key[k].buffer, s_op->resp.u.geteattr.val[k].buffer_sz);
        }
        /* in case of any errors, we initialize it to 0 */
        else {
            s_op->resp.u.geteattr.val[k].buffer_sz = 0;
        }
    }
    return 1;
}

/* geteattr_cleanup()
 * free resources alloc'd by state machine
 */
static int geteattr_cleanup(PINT_server_op *s_op, job_status_s *js_p)
{
    PINT_STATE_DEBUG("geteattr_cleanup");
    if (s_op->resp.u.geteattr.val)
        free(s_op->resp.u.geteattr.val);
    if (s_op->u.eattr.buffer)
        free(s_op->u.eattr.buffer);
    return(server_state_machine_complete(s_op));
}

/*
 * Local variables:
 *  mode: c
 *  c-indent-level: 4
 *  c-basic-offset: 4
 * End:
 *
 * vim: ft=c ts=8 sts=4 sw=4 expandtab
 */

